from optparse import make_option
from django.core.management.base import BaseCommand, CommandError

from awstrial.trial.models import Campaign
import sys

class Command(BaseCommand):
    option_list = BaseCommand.option_list + (
        make_option('--long', '-l', dest='long',
            help='Help for the long options'),
    )
    help = 'add a campaign. <name> <verbose_name> <number> <active>'

    def handle(self, *args, **options):
        active = True
        if len(args) == 3:
            (name,vname,number) = args
        elif len(args) == 3:
            (name,vname,number,active) = args
            if active in ("0", "False", "FALSE", "false"):
                active = False
            else:
                active = True
        else:
            print "%s\n  bad usage" % self.help
            sys.exit(1)

        ncampaign = Campaign(active=active, name=name,
            verbose_name=vname, max_instances=number)
        ncampaign.save()

        print "created %s with %s. active=%s" % (name, number, active)

# vi: ts=4 expandtab
