from optparse import make_option
from django.core.management.base import BaseCommand, CommandError

from awstrial.trial.models import Instances
from awstrial.trial import ec2_helper
from awstrial.trial import util
from awstrial import settings
from datetime import timedelta

class Command(BaseCommand):
    option_list = BaseCommand.option_list + (
        make_option('--long', '-l', dest='long',
            help='Help for the long options'),
    )
    help = 'Poll to check the status'



##### Some of this logic should be moved to ec2_helper IMO

    def handle(self, **options):
        instPerReg = { }
        for region in settings.REGION2AMI.keys():
            instances = Instances.objects.filter(terminated_time=None, region=region)
            #print "have %s instances in %s" % (len(instances),region)
            ec2_helper.update_instances(instances,region)
            instPerReg[region]=instances

        lifespan = timedelta(seconds=settings.LIFETIME)
        for region,instances in instPerReg.iteritems():
            dt = util.dtnow()
            tokill = [ ]
            for inst in instances:
                # ignore anything not 'running'
                if inst.status() != 'running': continue

                if inst.olderThan(lifespan, dt):
                    tokill.append(inst)

            if len(tokill):
                import sys; sys.stderr.write(
                    "killing in %s: %s\n" % (region,tokill))
                ec2_helper.terminate_instances(tokill,region)

# vi: ts=4 expandtab
