from trial.models import Campaign, Instances, Feedback
from awstrial.trial import ec2_helper, lp_helper, util
from awstrial import settings
from django.http import HttpResponse

def errmsg(msg):
    if settings.DEBUG:
        return("failed to register: %s\n" % msg)
    return("failed to register")

def phone_home(request,secret):
    pubkeys = request.POST.get('pubkeys','')
    iid = request.POST.get('instance-id','')
    if not iid:
        return HttpResponse(errmsg("iid not given"))

    res = Instances.objects.filter(instance_id=iid)

    # TODO: django doc indicates that len() on a QuerySet is
    # possibly bad.  but I dont think it necessarily is here
    if len(res) > 1:
        # uh-oh.  (this is actually possible, 
        # region/instance-id should be unique, but could have
        # duplicate instance-ids across regions
        return HttpResponse(errmsg("multiple matching instances: %s" % iid))

    # since there is only one item, this just gets it
    inst = None
    for inst in res: pass

    if not inst:
        return HttpResponse(errmsg("iid %s not found" % iid))

    # if the secret key doesn't match
    if secret != inst.secret:
        return HttpResponse(errmsg("invalid secret"))
    
    # if this instance is already registered
    if inst.pubkeys:
        return HttpResponse(errmsg("pubkeys already stored for %s" % iid))
    
    if inst.ph_time:
        return HttpResponse(errmsg("you only get one call home"))
    
    # we are good for registering
    inst.pubkeys = pubkeys
    inst.ph_time = util.dtnow()
    inst.save()

    return HttpResponse("registered keys %s\n" % iid)
	

# vi: ts=4 expandtab
