import datetime
from dateutil.tz import tzutc
from dateutil import parser 
from StringIO import StringIO
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart
from email import MIMEBase
import string
import random
import gzip

def dtnow():
	return(datetime.datetime.utcnow().replace(tzinfo=None))

def aws2datetime(awstime):
        return(parser.parse(awstime).replace(tzinfo=None))

CI_SCRIPT="text/x-shellscript"
CI_SCRIPT_START="#!"
CI_UPSTART="text/upstart-job"
CI_UPSTART_START="#upstart-job"
CI_BOOTHOOK="text/cloud-boothook"
CI_BOOTHOOK_START="#cloud-boothook"
CI_INCLUDE="text/x-include-url"
CI_INCLUDE_START="#include"
CI_CLOUDCONFIG="text/cloud-config"
CI_CLOUDCONFIG_START="#cloud-config"
CI_PARTHANDLER="text/part-handler"
CI_PARTHANDLER_START="#part-handler"

def rand_str(strlen=32):
    return("".join([random.choice(string.letters+string.digits)
        for x in range(0, strlen)]))

def guess_part_type(content):
    swith_map = {
        CI_INCLUDE_START : CI_INCLUDE,
        CI_SCRIPT_START : CI_SCRIPT,
        CI_CLOUDCONFIG_START : CI_CLOUDCONFIG,
        CI_UPSTART_START : CI_UPSTART,
        CI_PARTHANDLER_START : CI_PARTHANDLER,
        CI_BOOTHOOK_START : CI_BOOTHOOK,
    }
    for start,mtype in swith_map.items():
        if content.startswith(start):
            return(mtype)
    return(None)


# return a part item, that can then be fed as an item in a list
# to parts2mime
def partItem(part_content, part_type=None, filename=None):
    return((part_type,part_content,filename))

# plist expects to find a 
def parts2mime(plist, compress=True):
    count=0
    outer = MIMEMultipart()
    for item in plist:
        count=count+1
        (mtype,content,fname)=item
        if not mtype:
            mtype = guess_part_type(content)

        (maintype, subtype) = mtype.split('/', 1)
        if maintype == 'text':
            msg = MIMEText(content, _subtype=subtype)
        else:
            msg = MIMEBase(maintype, subtype)
            msg.set_payload(content)
            # Encode the payload using Base64
            encoders.encode_base64(msg)

        # Set the filename parameter
        if not fname:
            fname = 'mpart-%03d' % count

        msg.add_header('Content-Disposition', 'attachment',
            filename=fname)

        outer.attach(msg)

    if compress:
        ofile = StringIO()
        gfile = gzip.GzipFile(mode='wb',fileobj=ofile,filename="multipart-ud")
        gfile.write(outer.as_string())
        gfile.close()
        ofile.flush()
        return(ofile.getvalue())
    else:
        return(outer.as_string())

def find_config(config, configs):
    for c in configs:
        if c['name'] == config:
            return(c)
            break
    return None

# vi: ts=4 expandtab
