from django.conf.urls.defaults import *
from django.conf import settings
import ubuntu_website


from django.contrib import admin
admin.autodiscover()


urlpatterns = patterns('',
    (r'^$', 'trial.views.index'),
    (r'^(?P<campaign>[a-zA-Z0-9\-\.\+?]+)/running/', 'trial.views.reserved_instance'),
    (r'^(?P<campaign>[a-zA-Z0-9\-\.\+?]+)/start/', 'trial.views.start'),
    (r'^(?P<campaign>[a-zA-Z0-9\-\.\+?]+)/run/', 'trial.views.run_instance'),
    (r'^(?P<campaign>[a-zA-Z0-9\-\.\+?]+)/instance_info/', 'trial.views.info_instance'),

    (r'^feedback/', 'trial.views.feedback'),
    
    (r'^admin/', include(admin.site.urls)),
    (r'^openid/', include('django_openid_auth.urls')),
     (r'^logout/$', 'trial.views.logout_view'),

    (r'^phone_home/(?P<secret>[a-zA-Z0-9]+)/','trial.phone_home.phone_home'),
    (r'^faq/', 'django.views.generic.simple.direct_to_template', {'template': 'faq.html'}),
)

if settings.STATIC_SERVE:
    urlpatterns += patterns('',
        (r'^media/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
        (r'^(robots.txt)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
        (r'^ubuntu-website/media/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': ubuntu_website.MEDIA_ROOT}),
       
    )

